<?php
	function insert_button($button_file, $form_action, $user, $pass) {
		echo "<form action=\"" .$form_action ."\" method=\"post\">";
		echo "<input type=\"hidden\" name=\"user\" value=\"" .$user ."\">";
		echo "<input type=\"hidden\" name=\"pass\" value=\"" .$pass ."\">";
		echo "<input type=\"image\" src=\"../images/admin/" .$button_file ."\"></form>";
	}
	
	function insert_entry($file_name, $index, $entry) {
		$dat = file($file_name);
		$row_count = count($dat);
		
		$file_handle = fopen($file_name, "w+");

        //Anzeige der Einträge in umgekehrter Reihenfolge, löschen erfolgt aber mit der Liste in richtiger Reihenfolge
        $newid = $row_count - $index;
		
        //vor dem neuen Eintrag
		for ($row = 0; $row < $newid; $row++) {
			fwrite($file_handle, $dat[$row]);
		}

        //neuer Eintrag
		fwrite($file_handle, $entry ."\n");

        //nach dem neuen Eintrag
		for ($row = $newid; $row < $row_count; $row++) {
			fwrite($file_handle, $dat[$row]);
		}
		
		fclose($file_handle);
	}
	
	function delete_entry($file_name, $index) {
		$dat = file($file_name);
		$row_count = count($dat);
		
		$file_handle = fopen($file_name, 'w+');

        //Anzeige der Einträge in umgekehrter Reihenfolge, löschen erfolgt aber mit der Liste in richtiger Reihenfolge
        $deleteid = $row_count - $index -1;

		for ($row = 0; $row < $row_count; $row++) {
      		if ($row != $deleteid) {
	      		fwrite($file_handle, $dat[$row]);
			}
        }
        
		fclose($file_handle);
	}
	
	function create_user($new_username, $new_password, $new_rights, $entry_index) {
		$user_file = $new_username .".inc.php";
		$user_entry = $new_username ."#" .strtolower($new_rights);
		$user_pass = "<?php return \"" .$new_password ."\" ?>";
		insert_entry("user.dat.php", $entry_index, $user_entry);
		$file_handle = fopen($user_file, "w+");
		fwrite($file_handle, $user_pass);
		fclose($file_handle);
	}
	
	function display_delete_question($entry1, $entry2, $question, $do, $entry_index, $user, $pass) {
		echo "<tr><th colspan=\"2\">Soll " .$question ." wirklich gelöscht werden?";
		echo "<tr><td class=\"entry\" align=\"center\">" .$entry1;
		echo "<td class=\"entry\">" .$entry2;
		echo "<tr><td align=\"right\">";
		insert_button("ok.jpg", "index.php?do=$do&action=delok&entry_index=$entry_index", $user, $pass);
		echo "<td>";
		insert_button("abbrechen.jpg", "index.php?do=$do", $user, $pass);
	}
	
	function display_delete_ok($file_name, $entry_index, $message, $do, $user, $pass) {
		delete_entry($file_name, $entry_index);
		echo "<tr><th class=\"ok\">" .$message ." wurde entfernt!";
		echo "<tr><td align=\"center\">";
		insert_button("ok.jpg", "index.php?do=$do", $user, $pass);
	}
	
	function display_user_form($take, $do, $action, $entry_index, $user, $pass) {
		if ($take == "edit") {
			$user_data = file("user.dat.php");
			$user_details = explode("#", $user_data[$entry_index]);
			$user_pass = include($user_details[0] .".inc.php");
		}
		echo "<form action=\"index.php?do=$do&action=$action\" method=\"post\">";
		echo "<tr><th class=\"new\" width=\"50%\">Name:";
		if ($take == "new") {
			echo "<td class=\"entry\" width=\"50%\"><input type=\"text\" name=\"new_username\">";
		} else {
			if (trim(strtolower($user_details[1])) == "admin") {
				echo "<td class=\"entry\" width=\"50%\">" .$user_details[0];
			} else {
				echo "<td class=\"entry\" width=\"50%\"><input type=\"text\" value=\"" .$user_details[0] ."\" name=\"new_username\">";
			}
		}
		echo "<tr><th class=\"new\">Passwort:";
		if ($take == "new") {
			echo "<td class=\"entry\"><input type=\"password\" name=\"new_password\">";
		} else {
			echo "<td class=\"entry\"><input type=\"text\" value=\"" .$user_pass ."\"name=\"new_password\">";
		}
		echo "<tr><th class=\"new\">Rechte:";
		echo "<td class=\"entry\">";
		echo "<select name=\"new_rights\" size=\"2\">";
		if ($take == "new") {
			echo "<option>Admin</option>";
			echo "<option selected>User</user>";
		} else {
			if (trim(strtolower($user_details[1])) == "admin") {
				echo "<option selected>Admin</option>";
			} else {
				echo "<option>Admin</option>";
			}
			if (trim(strtolower($user_details[1])) == "user") {
				echo "<option selected>User</option>";
			} else {
				echo "<option>User</option>";
			}
		}
		echo "<tr><td align=\"right\">";
		if ($take == "edit") {
			echo "<input type=\"hidden\" name=\"self\" value=\"1\">";
		}
		echo "<input type=\"hidden\" name=\"user\" value=\"" .$user ."\">";
		echo "<input type=\"hidden\" name=\"pass\" value=\"" .$pass ."\">";
		if ($entry_index != "") {
			echo "<input type=\"hidden\" name=\"entry_index\" value=\"" .$entry_index ."\">";
		} else {
			echo "<input type=\"hidden\" name=\"entry_index\" value=\"0\">";
		}
		echo "<input type=\"image\" src=\"../images/admin/ok.jpg\">";
		echo "<td></form>";
		insert_button("abbrechen.jpg", "index.php?do=$do", $user, $pass);
	}

	function display_badword_form($take, $do, $action, $badword_index, $user, $pass) {
		if ($take == "edit") {
			$badword_data = file("../badwords.dat.php");
			$badword_details = explode("#", $badword_data[$badword_index]);
		}
		echo "<form action=\"index.php?do=$do&action=$action\" method=\"post\">";
		echo "<tr><th class=\"new\" width=\"50%\">Badword:";
		if ($take == "new") {
			echo "<td class=\"entry\" width=\"50%\"><input type=\"text\" name=\"new_badword\">";
		} else {
			echo "<td class=\"entry\" width=\"50%\"><input type=\"text\" value=\"" .$badword_details[0] ."\" name=\"new_badword\">";
		}
		echo "<tr><th class=\"new\">Ersetzen durch:";
		if ($take == "new") {
			echo "<td class=\"entry\"><input type=\"text\" name=\"new_replace\">";
		} else {
			echo "<td class=\"entry\"><input type=\"text\" value=\"" .$badword_details[1] ."\"name=\"new_replace\">";
		}
		
		echo "<tr><td align=\"right\">";
		echo "<input type=\"hidden\" name=\"user\" value=\"" .$user ."\">";
		echo "<input type=\"hidden\" name=\"pass\" value=\"" .$pass ."\">";
		if ($badword_index != "") {
			echo "<input type=\"hidden\" name=\"badword_index\" value=\"" .$badword_index ."\">";
		} else {
			echo "<input type=\"hidden\" name=\"badword_index\" value=\"0\">";
		}
		echo "<input type=\"image\" src=\"../images/admin/ok.jpg\">";
		echo "<td></form>";
		insert_button("abbrechen.jpg", "index.php?do=$do", $user, $pass);
	}
	
################################################################################

/**
 * Klasse für GB Admin
 */
class gb_admin
{
	var $str_file_entries;
	
	############################################################################
	
	function gb_admin()
	{
		$this->str_file_entries = '../gb.dat.php';
	}
	
	############################################################################
	
	/**
	 * Request
	 */
	function getRequest()
	{
		$_POST['user']	= isset($_POST['user'])?trim($_POST['user']):'';
		$_POST['pass']	= isset($_POST['pass'])?trim($_POST['pass']):'';
		$_GET['do']		= isset($_GET['do'])?trim($_GET['do']):'';
		$_GET['action']	= isset($_GET['action'])?trim($_GET['action']):'';
	}
	
	/**
	 * Validierung
	 */
	function validateForm()
	{
		if(!preg_match("/^[\w\d\.\-]{3,15}$/",$_POST['user'])) {
			$this->error('Ungültiger Benutzer', 'login.php');
		}
		
		if(!preg_match("/^.{3,15}$/",$_POST['pass'])) {
			$this->error('Ungültiges Passwort', 'login.php');
		}
		
		if(!preg_match("/^[\w]{0,10}$/",$_GET['do'])) {
			$this->error('wrong do', 'login.php');
		}
		
		if(!preg_match("/^[\w]{0,10}$/",$_GET['action'])) {
			$this->error('wrong action', 'login.php');
		}
	}
	
	/**
	 * Eintraege Datei öffnen
	 */
	function getEntrys($k=false)
	{
		if(is_file($this->str_file_entries))
		{
			$data = array_reverse(file($this->str_file_entries));
			
			$arr = array();
			foreach($data as $key=>$val)
			{
				$data2 = explode("#",$val);
				
				for($i=0;$i<=9;$i++) 
				{
					$arr[$key][$i] = isset($data2[$i])?trim($data2[$i]):'';
				}
			}
			
			if(false!==$k) {
				return $arr[$k];
			}
			
			return $arr;
		}
		else {
			$this->error('entries file dosn´t exists');
		}
	}
	
	/**
	 * Formular Eintrag editieren
	 * 
	 * @param $do
	 * @param $action
	 * @param $entry_index
	 * @param $user
	 * @param $pass
	 */
	function display_entry_form($do, $action, $entry_index, $user, $pass)
	{
		$entry_details = $this->getEntrys($entry_index);
		
		echo "<form action=\"index.php?do=$do&action=$action\" method=\"post\">";
		echo "<tr><th class=\"new\" width=\"50%\">Name:";
		echo "<td class=\"entry\" width=\"50%\"><input type=\"text\" name=\"new_name\" size=\"40\" value=\"" .$entry_details[0] ."\">";
		echo "<tr><th class=\"new\">IP:";
		echo "<td class=\"entry\"><input type=\"text\" name=\"new_ip\" size=\"40\" value=\"" .$entry_details[7] ."\">";
		echo "<tr><th class=\"new\">E-Mail:";
		echo "<td class=\"entry\"><input type=\"text\" name=\"new_email\" size=\"40\" value=\"" .$entry_details[1] ."\">";
		echo "<tr><th class=\"new\">URL:";
		echo "<td class=\"entry\"><input type=\"text\" name=\"new_url\" size=\"40\" value=\"" .$entry_details[2] ."\">";
		echo "<tr><th class=\"new\">Datum:";
		echo "<td class=\"entry\"><input type=\"text\" name=\"new_datum\" size=\"40\" value=\"" .$entry_details[4] ."\">";
		echo "<tr><th class=\"new\">Uhrzeit:";
		echo "<td class=\"entry\"><input type=\"text\" name=\"new_uhrzeit\" size=\"40\" value=\"" .$entry_details[5] ."\">";
		echo "<tr><th class=\"new\">Eintrag:";
		$text = urldecode($entry_details[3]);
		$text = str_replace("<br>", "\n", $text);
		$comment = urldecode($entry_details[8]);
		$comment = str_replace("<br>", "\n", $comment);
		echo "<td class=\"entry\"><textarea name=\"new_text\" cols=\"40\" rows=\"8\" wrap=\"physical\">" .$text ."</textarea>";
		if (($user == $entry_details[9]) or ($entry_details[8] == "")) {
			echo "<tr><th class=\"new\">Kommentar:";
			echo "<td class=\"entry\"><textarea name=\"new_comment\" cols=\"40\" rows=\"4\" wrap=\"physical\">" .$comment ."</textarea>";
		}
		
		echo "<input type=\"hidden\" name=\"new_user\" value=\"" .$user ."\">";
		echo "<input type=\"hidden\" name=\"new_icon\" value=\"" .$entry_details[6] ."\">";
		echo "<input type=\"hidden\" name=\"user\" value=\"" .$user ."\">";
		echo "<input type=\"hidden\" name=\"pass\" value=\"" .$pass ."\">";
		
		if ($entry_index != "") {
			echo "<input type=\"hidden\" name=\"entry_index\" value=\"" .$entry_index ."\">";
		}
		
		echo "<tr><td align=\"right\">";
		
		echo "<input type=\"image\" src=\"../images/admin/ok.jpg\">";
		echo "<td></form>";
		
		insert_button("abbrechen.jpg", "index.php?do=$do", $user, $pass);
	}
	
	/**
	 * Fehler und Abbruch
	 * @param $message
	 * @param $back_url
	 */
	function error($message, $back_url)
	{
		echo "</table><br><br><div align=\"center\" style=\"color : #ff0000\"><big><strong>";
		echo "Es ist ein Fehler aufgetreten</big><br><br>";
		echo $message;
		echo "</strong>";
		if ($back_url != "") echo "<br><br><a href=\"" .$back_url ."\"><img src=\"../images/admin/zurueck.jpg\" border=\"0\"></a>";
		echo "</div></body></html>";
		die();
	}
}
?>